<template>
    <div class="productForm">
        <form id="productCU" v-if="!loading && product">
              <div class="form-group">
                <label for="productName">Название</label>
                <input type="text" class="main-input" :class="{'invalid': checkRequired(product.productName)}" v-model="product.productName" name="productName" autocomplete="off">
              </div>

              <div class="form-group">
                <label for="productDescription">Описание</label>
                <input type="text" class="main-input" :class="{'invalid': checkRequired(product.productDescription)}" v-model="product.productDescription" name="productDescription" autocomplete="off">
              </div>

              <div class="form-group m-dropdown" v-click-outside="hideCategories">
                <label for="productCategory">Категория</label>
                
                <input class="main-input" :class="{'invalid': checkRequired(product.productCategory)}" @focus="showCategories = true;" autocomplete="off" name="productCategory" v-model="product.productCategory">

                <ul v-if="showCategories" class="m-dropdown-menu" >
                  <li v-for="c in categories" @click.stop="setCategory(c)">{{c}}</li>
                </ul>
              </div>
              <div class="form-group" style="max-width: 200px;">
                <label for="discount">Скидка</label>
                <input type="number" class="main-input" v-model="product.discount" name="discount" autocomplete="off">
              </div>
              <hr>

              <div class="upload-file-controls">
                <label @click="uploadType = 'images'" :class="{'invalid': checkRequired(product.files), 'active': uploadType === 'images'}">Фото</label>
                <span class="ml-1 mr-1">|</span>
                <label @click="uploadType = 'videos'" :class="{'active': uploadType === 'videos'}">Видео</label>
              </div>

              <div class="form-group" v-if="uploadType === 'images'">
                
                <upload @newFile="addNewFile"></upload>
              </div>
              <div class="form-group" v-if="uploadType === 'videos'">
                
                <video-upload @newVideo="addNewVideo"></video-upload>
              </div>

              <div class="product-images">
                <i class="fa fa-image" v-show="product.files.length < 1"></i>
                <div v-for="img in product.files.filter(f => !f.video)">
                  <img :src="img.url">
                  <div class="img-actions">
                    <i class="fa fa-remove" @click="removeImg(img)"></i>
                    <i class="fa fa-user" @click="makeMain(img)" :class="{'main-img': img.main}"></i>
                  </div>
                </div>
              </div>

              <div class="product-images mt-5">
                <div v-if="product.files.find(f => f.video)">
                  <video width="300" controls>
                    <source :src="product.files.find(f => f.video).url" type="video/mp4">
                    Your browser does not support HTML5 video.
                  </video>

                  <div class="img-actions">
                    <i class="fa fa-remove ml-2" @click="removeVideo(product.files.find(f => f.video))"></i>
                  </div>
                </div>
              </div>

              <hr>
              <div class="form-group">
                <label :class="{'invalid': checkRequired(product.items)}">Наименования Товара <i class="fa fa-plus-circle add-item" @click="addItem"></i></label>

                <div class="product-items">
                  <div v-for="i in product.items" class="product-item">
                    <i class="fa fa-remove item-remove" @click="removeItem(i)"></i>
                    <div class="product-item-input">
                      <label for="price">Цена</label>
                      <input type="text" class="main-input" :class="{'invalid': checkRequired(i.price)}" v-model="i.price"  autocomplete="off">
                    </div>

                    <div class="product-item-input">
                      <label for="type">Размер</label>
                      <input type="text" class="main-input" :class="{'invalid': checkRequired(i.type)}" v-model="i.type"  autocomplete="off">
                    </div>

                    <div class="product-item-input">
                      <label for="quantity">Количество</label>
                      <input type="text" class="main-input" :class="{'invalid': checkRequired(i.quantity)}" v-model="i.quantity"  autocomplete="off">
                    </div>
                  </div>
                </div>
              </div>
          <div>
            <hr>
            <p v-if="errorMsg" class="error-msg">{{errorMsg}}</p>
            <div class="d-flex">
              <button class="action-button main-button" @click="saveProduct">СОЗДАТЬ ТОВАР </button>
              <button v-if="editItem" class="action-button gray-button" @click="goBack">ВЕРНУТЬСЯ </button>
            </div>
          </div>
        </form>
        <modal :header="'Product Saved!'" :isShow="showModal" v-if="showModal" @close="showModal = false">
          <div slot="body">
            <p>Товар успешно сохранен!</p>
            <p>Нажмите <router-link :to="`/products/${newProductId}`" >здесь</router-link> чтобы посмотреть</p>
            
          </div>

          <div slot="footer">
            <button class="ml-2 ok-button action-button gray-button pull-right" @click="goBack">OK</button>
          </div>
        </modal>
    </div>
</template>
<script>
import axios from "axios";
import Upload from '../../shared/File-Upload.vue'
import VideoUpload from '../../shared/Video-Upload.vue'
import Modal from "../../shared/Modal";
export default {
  name: "productForm",
  data() {
    return {
      errorMsg: '',
      uploadType: 'images',
      categories: [],
      product: undefined,
      loading: false, saving: false, showCategories: false, showRequired: false, showModal: false
    };
  },
  methods: {
    saveProduct(e) {
      this.errorMsg = '';
      this.showRequired = false;
      e.preventDefault();
      if (!this.product.productName || !this.product.productCategory || this.product.items.length < 1 || this.product.files.length < 1 || itemsInvalid(this.product.items)) {
        this.showRequired = true;
        return this.errorMsg = 'Пожалуйста, заполните обязательные поля';
      }
      this.saving = true;
      e.target.disabled = true;

      let pr = this.editItem ? this.$http.put(`${process.env.VUE_APP_BASE_URL}/products`, this.product) : this.$http.post(`${process.env.VUE_APP_BASE_URL}/products`, this.product);
      
        pr.then(response => {
          this.saving = false;
          this.showModal = true;
          e.target.disabled = false;
          this.product = new Product();
          this.newProductId = response.data._id;
          if (this.editItem) {
            this.$emit('editItem', response.data);
          }
        })
        .catch(error => {
          console.log(error);
        });
    },
    checkRequired(i) {
      if (Array.isArray(i)) {
        return this.showRequired && i.length < 1;
      } else {
        return this.showRequired && !i;
      }
    },
    addNewFile(path) {
      let file = {'url': path, 'main': this.product.files.length < 1 ? true : false};
      if (this.product.files.length < 8) {
        this.product.files.push(file);
      }

      console.log(this.product.files);
    },
    addNewVideo(path) {
      let video = {'url': path, 'main': false, 'video': true};
      if (this.product.files.length < 8) {
        this.product.files = this.product.files.filter(f => !f.video);
        this.$nextTick(() => {
          this.product.files.push(video);
        });
      }
    },
    removeImg(img) {
      this.product.files = this.product.files.filter(f => f.url !== img.url);
      if (!this.product.files.find(f => f.main)) {
        this.product.files[0].main = true;
      }
    },
    removeVideo(video) {
      this.product.files = this.product.files.filter(f => !f.video);
    },
    removeItem(item) {
      this.product.items = this.product.items.filter(i => i._id !== item._id);
    },
    makeMain(img) {
      this.product.files.forEach(f => {
        f.main = false;
      });
      img.main = true;
    },
    setCategory(c) {
      this.product.productCategory = c;
      this.showCategories = false;
    },
    hideCategories() {
      this.showCategories = false;
    },

    getCategories() {
      axios
        .get(`${process.env.VUE_APP_BASE_URL}/products`)
        .then(response => {
          this.categories = response.data.map(p => p.productCategory).filter((c, ind, arr) => arr.indexOf(c) === ind);
          this.loading = false;
        })
        .catch(error => {
          console.log(error);
        });
    },
    addItem() {
      if (this.product.items.length < 6) {
        this.product.items.push(new Item());
      }
    },
    goBack() {
      if (!this.editItem) this.showModal = false;
      this.$emit('goBack');
    }
  },
  props: {
    editItem: Object
  },
  components: {
    Upload, VideoUpload, Modal
  },
  created() {
    this.loading = true;
    this.getCategories();
    this.product = this.editItem ? this.editItem : new Product();
    if (this.product.items.length < 1) {
      this.product.items.push(new Item());
    }
  }
};
function itemsInvalid(items) {
  return items.some(i => Object.keys(i).some(k => !i[k]));
}

function Item() {
  this._id = generateId(),
  this.price = '',
  this.type = '',
  this.quantity = '1'
}

function Product() {
  this.productName = '',
  this.productCategory = '',
  this.items = [],
  this.files = []
};

function generateId() {
  let timestamp = (new Date().getTime() / 1000 | 0).toString(16);
  return timestamp + 'xxxxxxxxxxxxxxxx'.replace(/[x]/g, function() {
    return (Math.random() * 16 | 0).toString(16);
  }).toLowerCase();
}
</script>
<style lang="scss">
.productForm {
  display: flex;
  justify-content: space-between;
  font-size: 14px;
  form {
    text-align: start;
    width: 100%;
  }
  .action-button {
    border-color: #f9f9f9;
  }
  
  #productCU {
    div {
      text-align: start;
    }
    button {
      text-align: center;
    }

    .gray-button {
      max-width: 300px;
    }
  }
  .add-item {
    color: gray;
    cursor: pointer;
    &:hover {
      color: #000;
    }
  }
  .product-items {
    display: flex;
    label {
      margin-bottom: 0;
    }
    .product-item-input {
      margin-bottom: 5px;
    }

    .product-item {
      padding: 0 10px;
      border-left: 1px solid lightgray;
      position: relative;
    }
    .product-item:first-child {
      padding-left: 0;
      border-left: unset;
    }
    .item-remove {
      position: absolute;
      right: 5px;
      color: #9c1212;
      cursor: pointer;
      &:hover {
        color: gray;
      }
    }
  }
  label.invalid {
    color: #9c1212;
  }
}

.product-images {
  display: flex;
  &.invalid {
    color: #9c1212;
  }
  & > div {
    margin-right: 10px;
    display: flex;
    .fa {
      cursor: pointer;
      &:hover {
        color: gray;
      }
    }
  }
  img {
    margin-right: 10px;
    max-height: 200px;
  }
  .main-img {
    color: $maincolor;
  }
  .fa-remove {
    color: #9c1212;
  }
  .img-actions {
    display: flex;
    flex-direction: column;
  }
  .fa-image {
    font-size: 38px;
  }
}
.upload-file-controls {
  label {
    cursor: pointer;
  }
  .active {
    color: blue;
  }
}
</style>